import java.util.ArrayList;

/**
 * Die Klasse Sudoku stellt die Methoden zur Interaktion bereit
 * 
 * @author (claus albowski) 
 * @version (Juni 15)
 */
public class Controller
{
    private Sudoku sudoku;
    private ArrayList<Sudoku> loesungen;

    /**
     * Konstruktor für Objekte der Klasse Sudoku
     */
    public Controller()
    {
        int[] sudokuDaten = new int[81];
        for (int i=0; i<81; i++) sudokuDaten[i]=0;
        sudoku = new Sudoku(sudokuDaten);
        loesungen = new ArrayList();
    }

    /**
     * get-Methode
     */
    public Sudoku gibSudoku() { return sudoku; }

    /**
     * die Methode zum Setzen der Felder
     * @param  zeile, spalte    int
     */
    public boolean belegeMit(int zeile, int spalte, int wert)
    {
        return sudoku.belegeMit(zeile,spalte,wert);
    }

    /**
     * fuehrt die Suche mit TS mit backtracking durch
     * die Verwaltung der sudokus erfolgt in dieser Klasse
     */
    public void suche()
    {
        Sudoku teilloesung = new Sudoku(sudoku.gibDaten());
        loesungen = new ArrayList();
        schritt(0, teilloesung, loesungen);
        for (Sudoku loesung : loesungen) loesung.zeige();

    }

    /**
     * fuehrt einen Suchschritt durch
     */
    public void schritt(int index, Sudoku teilloesung, ArrayList<Sudoku> loesungen)
    {
        if (index==81)
        {
            loesungen.add(teilloesung);
            return;
        }
        if (teilloesung.istBelegt(index))
        schritt(index+1, teilloesung, loesungen);
        else
        for (int wert=1; wert<10; wert++)
        {
            Sudoku neu = new Sudoku(teilloesung.gibDaten());
            if (neu.belegeMit(index/9+1,index%9+1,wert))
                schritt(index+1, neu, loesungen);
        }
    }

}
